 

' external data in data.o
Extern Sprites(0 To 45) Alias "SPRITES" As UByte Ptr Ptr
Extern Tiles(0 To 255, 0 To 15) Alias "TILES" As UByte
Extern Logo Alias "LOGO" As UByte
Extern Font(0 To 255, 0 To 15) Alias "FONT" As UByte
Extern StatusBars(0 To 6, 0 To 42) Alias "STATUSBAR1" As UByte
Extern Screens(0 To 91) As UByte Ptr
Extern Patterns(0 To 117) As UByte Ptr
Extern ScreenInfos(0 To 91) As UByte Ptr


'dim shared as ubyte pal(0 to 767)
'dim shared as ubyte scr(0 to 63999)

#define XRES 1024
#define YRES 768

Sub PutGeneric(x As Integer, y As Integer, xSize As Integer, ySize As Integer, p As UByte Ptr)

    Static As UByte smth(0 To 3) = {6, 4, 2, 0}
    Static As UByte CGA_Palette(0 To 3) = {0, 3, 5, 7}
    
    Static As Integer dx, dy

    For dy = 0 To ySize - 1
        For dx = 0 To xSize - 1
        	
            If x + dx >= 0 Then 
                If x + dx < XRES Then 
                    If y + dy >= 0 Then 
                        If y + dy < YRES Then
                       	 Poke((y + dy) * XRES + x + dx + SCREENPTR()), CGA_Palette((*p Shr smth(dx And 3)) And &h3)
                        End If
                    End If
                End If
            End If	
            If (dx And 3) = 3 Then p += 1
        Next	
    Next 	
End Sub

Sub PutBlank(x As Integer, y As Integer, p As UByte Ptr)
    Dim As Integer dx, dy, xsize, ysize
    
    xsize = *p * 4
    ysize = *(p + 1)
    For dy = 0 To ysize - 1
        For dx = 0 To xsize - 1
            If x + dx >= 0 Then 
                If x + dx < XRES Then 
                    If y + dy >= 0 Then 
                        If y + dy < YRES Then
                       	    Poke((y + dy) * XRES + x + dx + SCREENPTR()), 0
                        End If
                    End If
                End If
            End If	
        Next 
    Next 
End Sub

Sub PutSprite(x As Integer, y As Integer, p As UByte Ptr)
    PutGeneric x, y, *p Shl 2, *(p + 1), p + 2
End Sub

Sub PutTile(x As Integer, y As Integer, p As UByte Ptr)
    PutGeneric x, y, 8, 8, p
End Sub 


dim shared as integer frame_ubound(0 to 45) = { 6, 1, 2, 2, 2, 3, 1, 2, 3, 3, 3, 3, 1, 2, 1, 1, 1, 1, 1, 3, 1, 0, 3, 3, 3, 5, 1, 3, 3, 3, 5, 3, 5, 3, 3, 3, 3, 5, 3, 1, 1, 1, 3, 0, 0, 0}
dim shared as integer dy = 0, dx = 0

'' MAIN
'screen 13
screenres XRES, YRES, 8

for i as integer = 0 to 45	
	dx = 16	

	Draw String (0, dy), str(i)
	for f as integer = 0 to frame_ubound(i)
		

		PutSprite(dx, dy, *(Sprites(i) + f))
		dx += **(Sprites(i) + f) * 4
	next
	'dy += *(*(Sprites(i) + 0) + 1)
	dy += (*(Sprites(i) + 0))[1]
next
bsave "2.bmp", 0

cls
for y as integer = 0 to 24
	for x as integer = 0 to 39
		if y*40+x > 255 then continue for
		PutTile x*8, y*8, @Tiles(y*40+x, 0)
	next
next
for y as integer = 8 to 24
	for x as integer = 0 to 39
		if (y-8)*40+x > 87 then continue for
		PutTile x*8, y*8, @Font((y-8)*40+x, 0)
	next
next
bsave "3.bmp", 0

sleep
