

Dim Shared As UByte Ptr file
Dim Shared As String buffer
Dim Shared As Integer maxframes(0 To 45) = {6, 1, 2, 2, 2, 3, 1, 2, 3, 3, 3, 3, 1, 2, 1, 1, 1, 1, 1, 3, 1, 0, 3, 3, 3, 5, 1, 3, 3, 3, 5, 3, 5, 3, 3, 3, 5, 5, 1, 1, 1, 1, 3, 0, 0, 0} 

Declare Function lookup_num(As Integer) As Integer


Dim Shared As Integer lookup_table(0 To 999) ' should be enough

Function lookup_num(num As Integer) As Integer
    Static As Integer lookup_max = 0
    	
    For i As Integer = 0 To lookup_max
	   If lookup_table(i) = num Then Return -1
	Next

    lookup_table(lookup_max) = num	 
    lookup_max += 1
	Return 0
End Function

Dim Shared As Integer lookup2_max = 0
Function lookup_num2(num As Integer) As Integer
    
	
    For i As Integer = 0 To lookup2_max
	   If lookup_table(i) = num Then Return i
	Next

    lookup_table(lookup2_max) = num	 
    lookup2_max += 1
	Return lookup2_max - 1
End Function



'' main  
If Open("mision.com" For Binary Access Read As #1) Then
    Print "Error opening mision.com"
    Sleep  
End If

file = Callocate(61182)
Get #1, 1, *file, 61181 
Close #1

If Open("data.asm" For Output As #2) Then
    Print "Error creating data.asm"
    Sleep
End If

'' beginning of data file
Print #2, !".intel_syntax noprefix\r\n" + _
          !".section .data\r\n" + _
          !".balign 4\r\n" + _
          !".globl _SPRITES\r\n" + _
          !"_SPRITES:"

'' animated sprites table
For f1 As Integer = 0 To 8
    buffer = ".int "
    For f2 As Integer = 0 To 4
        buffer += "_sp_seq_" + Hex(Peek(Short, file + &h704a + (f1*5+f2)*2)) 
        If f2 < 4 Then buffer += ", " 
    Next
    Print #2, buffer
Next
Print #2, !".int _sp_seq_72C4"

'' sprite frames sequence
buffer = ".int "
For f As Integer = 0 To 45

    If f = 36 Then Continue For '' dirty hack
    If f = 38 Then Continue For '' dirty hack

    Print #2,"_sp_seq_" +  Hex(Peek(Short, file + &h704a + f*2)) + ":"

    For f2 As Integer = 0 To maxframes(f)
        buffer += "_sprite_" + Hex(Peek(UShort, Peek(Short, file + &h704a + f*2) + file - &h100 + f2*2))
        If f2 < maxframes(f) Then buffer += ", "
    Next
    Print #2, buffer
    buffer = ".int "
Next

'' sprite frames
Erase lookup_table
For f As Integer = 0 To 45
    For f2 As Integer = 0 To maxframes(f)
        Dim As Integer a, n, _x, _y 
        
        n = Peek(UShort, Peek(Short, file + &h704a + f*2) + file - &h100 + f2*2) 

        If lookup_num(n) = -1 Then Continue For  
        buffer = "_sprite_"  + Hex(n) + ":"
        Print #2, buffer
        
        a = file - &h100 + n
        _x = Peek(a): _y = Peek(a+1)
        buffer = ".byte " & _x & ", " & _y
        Print #2, buffer
        
        For y As Integer = 0 To (_y-1)
        	   buffer = ".byte "
            For x As Integer = 0 To (_x-1)
                buffer += Str(Peek(a + 2 + y*_x + x))
                If x < (_x-1) Then buffer += ", "           	
            Next
            Print #2, buffer
        Next
    Next
Next

'' tiles
Print #2, !".globl _TILES\r\n" + !"_TILES:"
For f As Integer = 0 To (&h1000 \ 16) - 1
	 buffer = ".byte "
    For f2 As Integer = 0 To 15
        	buffer += Str(Peek(file - &h100 + &h592e + f*16 + f2))
        	If f2 < 15 Then buffer += ", "
    Next
    Print #2, buffer
Next

' logo
Print #2, !".globl _LOGO\r\n" + !"_LOGO:\r\n" + !".byte 33, 48"
For y As Integer = 0 To 47
	buffer = ".byte "
    For x As Integer = 0 To 32
        buffer += Str(Peek(file -&h100 + &ha7e0 + y*33 + x))
        If x < 32 Then buffer += ", "    
    Next 
    Print #2, buffer
Next

' font tiles
Print #2, !".globl _FONT\r\n" + !"_FONT:"
For y As Integer = 0 To 87'255
    buffer = ".byte "
    For x As Integer = 0 To 15
        buffer += Str(Peek(file -&h100 + &h4901 + y*16 + x))
        If x < 15 Then buffer += ", "        
    Next
    Print #2, buffer
Next 

'statusbars 43
For f As Integer = 0 To 6
    Print #2, !".globl _STATUSBAR" + Str(f+1) + !"\r\n" + !"_STATUSBAR" + Str(f+1) + ":"
    buffer = ".byte "
    For x As Integer = 0 To 42
        buffer += Str(Peek(file - &h100 + &hb034 + f*43 + x))
        If x < 42 Then buffer += ", "
    Next
    Print #2, buffer
Next 

' screen array
Print #2, !".globl _SCREENS\r\n" + !"_SCREENS:"
For y As Integer = 0 To 18
    buffer = ".int "
    For x As Integer = 0 To 4
        buffer += "_screen" + Str(y*5+x)
        If (y * 5)+ x = 91 Then Exit For 
        If x < 4 Then buffer += ", "
    Next
    Print #2, buffer
Next 

' screen data chunks
Erase lookup_table
For i As Integer = 0 To 91
    Dim As UByte Ptr p
    Print #2, "_screen" + Str(i) + ":"
    p = file - &h100 + &h2d4f + Peek(UShort, file - &h100 + &h7092 + i*2) 
    Print #2, ".byte " + Str(Peek(p))
    For y As Integer = 0 To Peek(p) - 1
        
        Print #2, ".byte " + Str(Peek(p + 1)) + ", " + Str(Peek(p + 2)) + ", " + Str(lookup_num2(Peek(UShort, p + 3))) + ", 0"
        p += 4
    Next 
Next

' patterns array
Print #2, !".globl _PATTERNS\r\n" + !"_PATTERNS:"
For y As Integer = 0 To 14
    buffer = ".int "
    For x As Integer = 0 To 7
        buffer += "_pattern" + Str(y*8+x)
        If (y * 8)+ x = 117 Then Exit For 
        If x < 7 Then buffer += ", "
    Next 
    Print #2, buffer
Next 

' patterns
Scope
   Dim As Integer i = 0
       While lookup_table(i) <> 0
           Dim As UByte Ptr p
           p = file - &h100 + &h692e + lookup_table(i)        
           Print #2, "_pattern" + Str(i) + !":\r\n.byte " + Str(*p) + ", " + Str(*(p+1))
               For y As Integer = 0 To *(p+1)-1
                   buffer = ".byte "
                   For x As Integer = 0 To *p-1
                       buffer += Str(*(p+2 + y * *p + x))
                       If x < *p-1 Then buffer += ", "
                   Next 
                   Print #2, buffer
               Next 
           i += 1
       Wend 
End Scope 

' screeninfos array
Print #2, !".globl _SCREENINFOS\r\n" + !"_SCREENINFOS:"
For y As Integer = 0 To 18
    buffer = ".int "
    For x As Integer = 0 To 4
        buffer += "_screeninfo" + Str(y*5+x)
        If (y * 5)+ x = 91 Then Exit For 
        If x < 4 Then buffer += ", "
    Next
    Print #2, buffer
Next 

Print #2, _
!"##  screen up, screen right, screen down, screen left,\r\n" + _
!"##  number of enemies,\r\n" + _
!"##  base(128) or bridge(64) or other,\r\n" + _
!"##      sprite index, x, y,\r\n" + _
!"##         speed, minframe, maxframe,\r\n" + _
!"##             procedure index\r\n\r\n"

' screeninfo chunks
Erase lookup_table
lookup2_max = 0
For f As Integer = 0 To 91
    Dim As UByte Ptr p
    Dim As Integer f2
    Print #2, "_screeninfo" + Str(f) + ":"
    p = Peek(UShort, file - &h100 + &h786c + f*2) + file - &h100
    Print #2, ".byte " + Str(*p) + ", " + Str(*(p+1)) + ", " + Str(*(p+2)) + ", " + Str(*(p+3))
    Print #2, ".byte " + Str(*(p+4))
    
    f2 = *(p+4)
    p += 5
    
    While f2 > 0
        dim as integer temp_sprite_number = *(p+1)
        
        buffer = ".byte " + _
                 Str(*(p+0)) + ", " + Str(*(p+1)) + ", " + _
                 Str(*(p+3)) + ", " + Str(*(p+4)) + ",             "
        Scope 
            Dim As UByte Ptr p2
            Dim As UByte temp
            p2 = file - &h100 + Peek(UShort, p + 5)
            buffer += Str(*p2) + ", " + Str(*(p2+1)) + ", " + Str(*(p2+2)) + ", "


            temp = lookup_num2(Peek(UShort, p2 + 5))
            If temp = 3 Then temp = IIf(Peek(UByte, p2 + 8) <> 0, 7, 3) 
            buffer += Str(temp) + "   ## " + Hex(Peek(UShort, p2 + 5)) 
        End Scope 
        
        Print #2, buffer
        p += 7
        f2 -= 1
    Wend   
    If *(p) = 0 Then buffer = ".byte 0 ## no screen procedure"
    If *(p) = 1 Then
        If Peek(UShort, p + 1) = &h2016 Then buffer = ".byte 1 ## right elevator"
        If Peek(UShort, p + 1) = &h1ff8 Then buffer = ".byte 2 ## left elevator"
        If Peek(UShort, p + 1) = &h147a Then buffer = ".byte 3 ## final screen"
    End If  
    Print #2, buffer
Next 

Close #2
/'
If Open("palette.asm" For Output As #2) Then
    Print "Error creating palette.asm"
    Sleep
End If

'' beginning of data file
Print #2, !".intel_syntax noprefix\r\n" + _
          !".section .data\r\n" + _
          !".balign 4\r\n" 


buffer = _ 
!".balign 4\r\n.globl _GAMEPALETTE\r\n_GAMEPALETTE:\r\n" + _
!".byte 0x00, 0x00, 0x00, 0x00, 0xAA, 0x00, 0x00, 0x00, 0x00, 0xAA, 0x00, 0x00, 0xAA, 0xAA, 0x00, 0x00\r\n" + _ 
!".byte 0x00, 0x00, 0xAA, 0x00, 0xAA, 0x00, 0xAA, 0x00, 0x00, 0x55, 0xAA, 0x00, 0xAA, 0xAA, 0xAA, 0x00\r\n" + _ 
!".byte 0x55, 0x55, 0x55, 0x00, 0xFF, 0x55, 0x55, 0x00, 0x55, 0xFF, 0x55, 0x00, 0xFF, 0xFF, 0x55, 0x00\r\n" + _ 
!".byte 0x55, 0x55, 0xFF, 0x00, 0xFF, 0x55, 0xFF, 0x00, 0x55, 0xFF, 0xFF, 0x00, 0xFF, 0xFF, 0xFF, 0x00\r\n" + _
!".byte 0x00, 0x00, 0x00, 0x00, 0x14, 0x14, 0x14, 0x00, 0x20, 0x20, 0x20, 0x00, 0x2C, 0x2C, 0x2C, 0x00\r\n" + _ 
!".byte 0x38, 0x38, 0x38, 0x00, 0x44, 0x44, 0x44, 0x00, 0x50, 0x50, 0x50, 0x00, 0x61, 0x61, 0x61, 0x00\r\n" + _ 
!".byte 0x71, 0x71, 0x71, 0x00, 0x81, 0x81, 0x81, 0x00, 0x91, 0x91, 0x91, 0x00, 0xA1, 0xA1, 0xA1, 0x00 \r\n" + _
!".byte 0xB6, 0xB6, 0xB6, 0x00, 0xCA, 0xCA, 0xCA, 0x00, 0xE2, 0xE2, 0xE2, 0x00, 0xFF, 0xFF, 0xFF, 0x00 \r\n" + _
!".byte 0xFF, 0x00, 0x00, 0x00, 0xFF, 0x00, 0x40, 0x00, 0xFF, 0x00, 0x7D, 0x00, 0xFF, 0x00, 0xBE, 0x00 \r\n" + _
!".byte 0xFF, 0x00, 0xFF, 0x00, 0xBE, 0x00, 0xFF, 0x00, 0x7D, 0x00, 0xFF, 0x00, 0x40, 0x00, 0xFF, 0x00 \r\n" + _
!".byte 0x00, 0x00, 0xFF, 0x00, 0x00, 0x40, 0xFF, 0x00, 0x00, 0x7D, 0xFF, 0x00, 0x00, 0xBE, 0xFF, 0x00 \r\n" + _
!".byte 0x00, 0xFF, 0xFF, 0x00, 0x00, 0xFF, 0xBE, 0x00, 0x00, 0xFF, 0x7D, 0x00, 0x00, 0xFF, 0x40, 0x00 \r\n" + _
!".byte 0x00, 0xFF, 0x00, 0x00, 0x40, 0xFF, 0x00, 0x00, 0x7D, 0xFF, 0x00, 0x00, 0xBE, 0xFF, 0x00, 0x00 \r\n" + _
!".byte 0xFF, 0xFF, 0x00, 0x00, 0xFF, 0xBE, 0x00, 0x00, 0xFF, 0x7D, 0x00, 0x00, 0xFF, 0x40, 0x00, 0x00 \r\n" + _
!".byte 0xFF, 0x7D, 0x7D, 0x00, 0xFF, 0x7D, 0x9D, 0x00, 0xFF, 0x7D, 0xBE, 0x00, 0xFF, 0x7D, 0xDE, 0x00 \r\n" + _
!".byte 0xFF, 0x7D, 0xFF, 0x00, 0xDE, 0x7D, 0xFF, 0x00, 0xBE, 0x7D, 0xFF, 0x00, 0x9D, 0x7D, 0xFF, 0x00 \r\n" + _
!".byte 0x7D, 0x7D, 0xFF, 0x00, 0x7D, 0x9D, 0xFF, 0x00, 0x7D, 0xBE, 0xFF, 0x00, 0x7D, 0xDE, 0xFF, 0x00 \r\n" + _
!".byte 0x7D, 0xFF, 0xFF, 0x00, 0x7D, 0xFF, 0xDE, 0x00, 0x7D, 0xFF, 0xBE, 0x00, 0x7D, 0xFF, 0x9D, 0x00 \r\n" + _
!".byte 0x7D, 0xFF, 0x7D, 0x00, 0x9D, 0xFF, 0x7D, 0x00, 0xBE, 0xFF, 0x7D, 0x00, 0xDE, 0xFF, 0x7D, 0x00 \r\n" + _
!".byte 0xFF, 0xFF, 0x7D, 0x00, 0xFF, 0xDE, 0x7D, 0x00, 0xFF, 0xBE, 0x7D, 0x00, 0xFF, 0x9D, 0x7D, 0x00 \r\n" + _
!".byte 0xFF, 0xB6, 0xB6, 0x00, 0xFF, 0xB6, 0xC6, 0x00, 0xFF, 0xB6, 0xDA, 0x00, 0xFF, 0xB6, 0xEA, 0x00 \r\n" + _
!".byte 0xFF, 0xB6, 0xFF, 0x00, 0xEA, 0xB6, 0xFF, 0x00, 0xDA, 0xB6, 0xFF, 0x00, 0xC6, 0xB6, 0xFF, 0x00 \r\n" + _
!".byte 0xB6, 0xB6, 0xFF, 0x00, 0xB6, 0xC6, 0xFF, 0x00, 0xB6, 0xDA, 0xFF, 0x00, 0xB6, 0xEA, 0xFF, 0x00 \r\n" + _
!".byte 0xB6, 0xFF, 0xFF, 0x00, 0xB6, 0xFF, 0xEA, 0x00, 0xB6, 0xFF, 0xDA, 0x00, 0xB6, 0xFF, 0xC6, 0x00 \r\n" + _
!".byte 0xB6, 0xFF, 0xB6, 0x00, 0xC6, 0xFF, 0xB6, 0x00, 0xDA, 0xFF, 0xB6, 0x00, 0xEA, 0xFF, 0xB6, 0x00 \r\n" + _
!".byte 0xFF, 0xFF, 0xB6, 0x00, 0xFF, 0xEA, 0xB6, 0x00, 0xFF, 0xDA, 0xB6, 0x00, 0xFF, 0xC6, 0xB6, 0x00 \r\n" + _
!".byte 0x71, 0x00, 0x00, 0x00, 0x71, 0x00, 0x1C, 0x00, 0x71, 0x00, 0x38, 0x00, 0x71, 0x00, 0x55, 0x00 \r\n" + _
!".byte 0x71, 0x00, 0x71, 0x00, 0x55, 0x00, 0x71, 0x00, 0x38, 0x00, 0x71, 0x00, 0x1C, 0x00, 0x71, 0x00 \r\n" + _
!".byte 0x00, 0x00, 0x71, 0x00, 0x00, 0x1C, 0x71, 0x00, 0x00, 0x38, 0x71, 0x00, 0x00, 0x55, 0x71, 0x00 \r\n" + _
!".byte 0x00, 0x71, 0x71, 0x00, 0x00, 0x71, 0x55, 0x00, 0x00, 0x71, 0x38, 0x00, 0x00, 0x71, 0x1C, 0x00 \r\n" + _
!".byte 0x00, 0x71, 0x00, 0x00, 0x1C, 0x71, 0x00, 0x00, 0x38, 0x71, 0x00, 0x00, 0x55, 0x71, 0x00, 0x00 \r\n" + _
!".byte 0x71, 0x71, 0x00, 0x00, 0x71, 0x55, 0x00, 0x00, 0x71, 0x38, 0x00, 0x00, 0x71, 0x1C, 0x00, 0x00 \r\n" + _
!".byte 0x71, 0x38, 0x38, 0x00, 0x71, 0x38, 0x44, 0x00, 0x71, 0x38, 0x55, 0x00, 0x71, 0x38, 0x61, 0x00 \r\n" + _
!".byte 0x71, 0x38, 0x71, 0x00, 0x61, 0x38, 0x71, 0x00, 0x55, 0x38, 0x71, 0x00, 0x44, 0x38, 0x71, 0x00 \r\n" + _
!".byte 0x38, 0x38, 0x71, 0x00, 0x38, 0x44, 0x71, 0x00, 0x38, 0x55, 0x71, 0x00, 0x38, 0x61, 0x71, 0x00 \r\n" + _
!".byte 0x38, 0x71, 0x71, 0x00, 0x38, 0x71, 0x61, 0x00, 0x38, 0x71, 0x55, 0x00, 0x38, 0x71, 0x44, 0x00 \r\n" + _
!".byte 0x38, 0x71, 0x38, 0x00, 0x44, 0x71, 0x38, 0x00, 0x55, 0x71, 0x38, 0x00, 0x61, 0x71, 0x38, 0x00 \r\n" + _
!".byte 0x71, 0x71, 0x38, 0x00, 0x71, 0x61, 0x38, 0x00, 0x71, 0x55, 0x38, 0x00, 0x71, 0x44, 0x38, 0x00 \r\n" + _
!".byte 0x71, 0x50, 0x50, 0x00, 0x71, 0x50, 0x59, 0x00, 0x71, 0x50, 0x61, 0x00, 0x71, 0x50, 0x69, 0x00 \r\n" + _
!".byte 0x71, 0x50, 0x71, 0x00, 0x69, 0x50, 0x71, 0x00, 0x61, 0x50, 0x71, 0x00, 0x59, 0x50, 0x71, 0x00 \r\n" + _
!".byte 0x50, 0x50, 0x71, 0x00, 0x50, 0x59, 0x71, 0x00, 0x50, 0x61, 0x71, 0x00, 0x50, 0x69, 0x71, 0x00 \r\n" + _
!".byte 0x50, 0x71, 0x71, 0x00, 0x50, 0x71, 0x69, 0x00, 0x50, 0x71, 0x61, 0x00, 0x50, 0x71, 0x59, 0x00 \r\n" + _
!".byte 0x50, 0x71, 0x50, 0x00, 0x59, 0x71, 0x50, 0x00, 0x61, 0x71, 0x50, 0x00, 0x69, 0x71, 0x50, 0x00 \r\n" + _
!".byte 0x71, 0x71, 0x50, 0x00, 0x71, 0x69, 0x50, 0x00, 0x71, 0x61, 0x50, 0x00, 0x71, 0x59, 0x50, 0x00 \r\n" + _
!".byte 0x40, 0x00, 0x00, 0x00, 0x40, 0x00, 0x10, 0x00, 0x40, 0x00, 0x20, 0x00, 0x40, 0x00, 0x30, 0x00 \r\n" + _
!".byte 0x40, 0x00, 0x40, 0x00, 0x30, 0x00, 0x40, 0x00, 0x20, 0x00, 0x40, 0x00, 0x10, 0x00, 0x40, 0x00 \r\n" + _
!".byte 0x00, 0x00, 0x40, 0x00, 0x00, 0x10, 0x40, 0x00, 0x00, 0x20, 0x40, 0x00, 0x00, 0x30, 0x40, 0x00 \r\n" + _
!".byte 0x00, 0x40, 0x40, 0x00, 0x00, 0x40, 0x30, 0x00, 0x00, 0x40, 0x20, 0x00, 0x00, 0x40, 0x10, 0x00 \r\n" + _
!".byte 0x00, 0x40, 0x00, 0x00, 0x10, 0x40, 0x00, 0x00, 0x20, 0x40, 0x00, 0x00, 0x30, 0x40, 0x00, 0x00 \r\n" + _
!".byte 0x40, 0x40, 0x00, 0x00, 0x40, 0x30, 0x00, 0x00, 0x40, 0x20, 0x00, 0x00, 0x40, 0x10, 0x00, 0x00 \r\n" + _
!".byte 0x40, 0x20, 0x20, 0x00, 0x40, 0x20, 0x28, 0x00, 0x40, 0x20, 0x30, 0x00, 0x40, 0x20, 0x38, 0x00 \r\n" + _
!".byte 0x40, 0x20, 0x40, 0x00, 0x38, 0x20, 0x40, 0x00, 0x30, 0x20, 0x40, 0x00, 0x28, 0x20, 0x40, 0x00 \r\n" + _
!".byte 0x20, 0x20, 0x40, 0x00, 0x20, 0x28, 0x40, 0x00, 0x20, 0x30, 0x40, 0x00, 0x20, 0x38, 0x40, 0x00 \r\n" + _
!".byte 0x20, 0x40, 0x40, 0x00, 0x20, 0x40, 0x38, 0x00, 0x20, 0x40, 0x30, 0x00, 0x20, 0x40, 0x28, 0x00 \r\n" + _
!".byte 0x20, 0x40, 0x20, 0x00, 0x28, 0x40, 0x20, 0x00, 0x30, 0x40, 0x20, 0x00, 0x38, 0x40, 0x20, 0x00 \r\n" + _
!".byte 0x40, 0x40, 0x20, 0x00, 0x40, 0x38, 0x20, 0x00, 0x40, 0x30, 0x20, 0x00, 0x40, 0x28, 0x20, 0x00 \r\n" + _
!".byte 0x40, 0x2C, 0x2C, 0x00, 0x40, 0x2C, 0x30, 0x00, 0x40, 0x2C, 0x34, 0x00, 0x40, 0x2C, 0x3C, 0x00 \r\n" + _
!".byte 0x40, 0x2C, 0x40, 0x00, 0x3C, 0x2C, 0x40, 0x00, 0x34, 0x2C, 0x40, 0x00, 0x30, 0x2C, 0x40, 0x00 \r\n" + _
!".byte 0x2C, 0x2C, 0x40, 0x00, 0x2C, 0x30, 0x40, 0x00, 0x2C, 0x34, 0x40, 0x00, 0x2C, 0x3C, 0x40, 0x00 \r\n" + _
!".byte 0x2C, 0x40, 0x40, 0x00, 0x2C, 0x40, 0x3C, 0x00, 0x2C, 0x40, 0x34, 0x00, 0x2C, 0x40, 0x30, 0x00 \r\n" + _
!".byte 0x2C, 0x40, 0x2C, 0x00, 0x30, 0x40, 0x2C, 0x00, 0x34, 0x40, 0x2C, 0x00, 0x3C, 0x40, 0x2C, 0x00 \r\n" + _
!".byte 0x40, 0x40, 0x2C, 0x00, 0x40, 0x3C, 0x2C, 0x00, 0x40, 0x34, 0x2C, 0x00, 0x40, 0x30, 0x2C, 0x00 \r\n" + _
!".byte 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00\r\n" + _
!".byte 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00\r\n"
Print #2, buffer

Close #2
'/