

Dim Shared As UByte Ptr file
Dim Shared As String buffer
Dim Shared As Integer maxframes(0 To 45) = {6, 1, 2, 2, 2, 3, 1, 2, 3, 3, 3, 3, 1, 2, 1, 1, 1, 1, 1, 3, 1, 0, 3, 3, 3, 5, 1, 3, 3, 3, 5, 3, 5, 3, 3, 3, 5, 5, 1, 1, 1, 1, 3, 0, 0, 0} 

Declare Function lookup_num(As Integer) As Integer


Dim Shared As Integer lookup_table(0 To 999) ' should be enough

Function lookup_num(num As Integer) As Integer
    Static As Integer lookup_max = 0
    	
    For i As Integer = 0 To lookup_max
	   If lookup_table(i) = num Then Return -1
	Next

    lookup_table(lookup_max) = num	 
    lookup_max += 1
	Return 0
End Function

Dim Shared As Integer lookup2_max = 0
Function lookup_num2(num As Integer) As Integer
    
	
    For i As Integer = 0 To lookup2_max
	   If lookup_table(i) = num Then Return i
	Next

    lookup_table(lookup2_max) = num	 
    lookup2_max += 1
	Return lookup2_max - 1
End Function



'' main  
If Open("mision.com" For Binary Access Read As #1) Then
    Print "Error opening mision.com"
    Sleep  
	end 0
End If

file = Callocate(61182)
Get #1, 1, *file, 61181 
Close #1

If Open("m_data.c" For Output As #2) Then
    Print "Error creating m_data.c"
    Sleep
	end 0
End If

'' beginning of data file
Print #2, !"#ifndef __GCC__\r\n" + _
          !"#define __attribute__(A)\r\n" + _
          !"#endif\r\n" + _
          !"\r\n" 
		  

		  

'' sprite frames
Erase lookup_table
For f As Integer = 0 To 45
    For f2 As Integer = 0 To maxframes(f)
        Dim As Integer a, n, _x, _y 
        
        n = Peek(UShort, Peek(Short, file + &h704a + f*2) + file - &h100 + f2*2) 

        If lookup_num(n) = -1 Then Continue For  
        buffer = "unsigned char sprite_"  + Hex(n) + "[] __attribute__ ((aligned(4))) = {"
        Print #2, buffer
        
        a = file - &h100 + n
        _x = Peek(a): _y = Peek(a+1)
        buffer = !"\t " & _x & ", " & _y & ", "
        Print #2, buffer
        
        For y As Integer = 0 To (_y-1)
        	   buffer = !"\t "
            For x As Integer = 0 To (_x-1)
                buffer += Str(Peek(a + 2 + y*_x + x))
                If x = (_x-1) andalso y= (_y-1) Then exit for
				buffer += ", "           	
            Next
            Print #2, buffer
        Next
		Print #2, !"};"
    Next
Next

'' sprite frames sequence
buffer = !"\t "
For f As Integer = 0 To 45

    If f = 36 Then Continue For '' dirty hack
    If f = 38 Then Continue For '' dirty hack

    Print #2,"unsigned char *sp_seq_" +  Hex(Peek(Short, file + &h704a + f*2)) + "[] = {"

    For f2 As Integer = 0 To maxframes(f)
        buffer += "sprite_" + Hex(Peek(UShort, Peek(Short, file + &h704a + f*2) + file - &h100 + f2*2))
        If f2 = maxframes(f) Then exit for
		buffer += ", "
    Next
    buffer += !"\r\n\};"
	Print #2, buffer
    buffer = !"\t "
Next
		  
'' animated sprites table
Print #2, !"unsigned char **SPRITES[46] = {"
For f1 As Integer = 0 To 8
    buffer = !"\t "
    For f2 As Integer = 0 To 4
        buffer += "sp_seq_" + Hex(Peek(Short, file + &h704a + (f1*5+f2)*2)) 
        'If f2 < 4 Then 
		buffer += ", " 
    Next
    Print #2, buffer
Next
Print #2, !"\t sp_seq_72C4\r\n};\r\n"

'' tiles
Print #2, !"unsigned char TILES[] = {"
For f As Integer = 0 To (&h1000 \ 16) - 1
	 buffer = !"\t "
    For f2 As Integer = 0 To 15
        	buffer += Str(Peek(file - &h100 + &h592e + f*16 + f2))
        	If f2 = 15 andalso f = (&h1000 \ 16) - 1 Then exit for
			buffer += ", "
    Next	
    Print #2, buffer
Next
Print #2, !"};"

' logo
Print #2, !"unsigned char LOGO[] = {\r\n\t 33, 48,"
For y As Integer = 0 To 47
	buffer = !"\t "
    For x As Integer = 0 To 32
        buffer += Str(Peek(file -&h100 + &ha7e0 + y*33 + x))
        If x = 32 andalso y = 47 Then exit for
		buffer += ", "    
    Next 
    Print #2, buffer
Next
Print #2, !"};"

' font tiles
Print #2, !"unsigned char FONT[] = {"
For y As Integer = 0 To 87'255
    buffer = !"\t "
    For x As Integer = 0 To 15
        buffer += Str(Peek(file - &h100 + &h4901 + y*16 + x))
        If x = 15 andalso y = 87 Then exit for
		buffer += ", "        
    Next
    Print #2, buffer
Next 
Print #2, !"};"

'statusbars 43
Print #2, !"unsigned char STATUSBAR1[] = {"
For f As Integer = 0 To 6
    
    buffer = !"\t "
    For x As Integer = 0 To 42
        buffer += Str(Peek(file - &h100 + &hb034 + f*43 + x))
        If x = 42 andalso f = 6 Then exit for
		buffer += ", "
    Next
	'buffer += !"\r\n};"
    Print #2, buffer
Next 
Print #2, !"};"

' screen data chunks
Erase lookup_table
For i As Integer = 0 To 91
    Dim As UByte Ptr p
	dim as integer peek_p_1
    Print #2, "unsigned char screen" + Str(i) + "[] = {"
    p = file - &h100 + &h2d4f + Peek(UShort, file - &h100 + &h7092 + i*2) 
    Print #2, !"\t " + Str(Peek(p)) + ", "
	peek_p_1 = Peek(p) - 1
    For y As Integer = 0 To Peek(p) - 1
        
        buffer =!"\t " + Str(Peek(p + 1)) + ", " + Str(Peek(p + 2)) + ", " + Str(lookup_num2(Peek(UShort, p + 3))) + ", 0"
		if y <> peek_p_1 then buffer += ","
		Print #2, buffer
        p += 4
    Next 
	Print #2, !"};"
Next

' screen array
Print #2, !"unsigned char *SCREENS[92] = {"
For y As Integer = 0 To 18
    buffer = !"\t "
    For x As Integer = 0 To 4
        buffer += "screen" + Str(y*5+x)
        If (y * 5)+ x = 91 Then Exit For 
        If x = 4 andalso y = 18 Then exit for
		buffer += ", "
    Next
    Print #2, buffer
Next 
Print #2, !"};"

' patterns
Scope
   Dim As Integer i = 0
       While lookup_table(i) <> 0
           Dim As UByte Ptr p
           p = file - &h100 + &h692e + lookup_table(i)        
           Print #2, "unsigned char pattern" + Str(i) + !"[] = {\r\n\t " + Str(*p) + ", " + Str(*(p+1)) + ", "
               For y As Integer = 0 To *(p+1)-1
                   buffer = !"\t "
                   For x As Integer = 0 To *p-1
                       buffer += Str(*(p+2 + y * *p + x))
                       If x = *p-1 andalso y = *(p+1)-1 Then exit for
					   buffer += ", "
                   Next 
                   Print #2, buffer
               Next 
           i += 1
		   Print #2, !"};"
       Wend 
End Scope 

' patterns array
Print #2, !"unsigned char *PATTERNS[118] = {"
For y As Integer = 0 To 14
    buffer = !"\t "
    For x As Integer = 0 To 7
        buffer += "pattern" + Str(y*8+x)
        If (y * 8)+ x = 117 Then Exit For 
        If x = 7 andalso y = 14 Then exit for
		buffer += ", "
    Next 
    Print #2, buffer
Next 
Print #2, !"};"



Print #2, _
!"//  screen up, screen right, screen down, screen left,\r\n" + _
!"//  number of enemies,\r\n" + _
!"//  base(128) or bridge(64) or 0,\r\n" + _
!"//      sprite index, x, y,\r\n" + _
!"//         speed, minframe, maxframe, ai type\r\n" + _
!"//             procedure index\r\n\r\n"

' screeninfo chunks
Erase lookup_table
lookup2_max = 0
For f As Integer = 0 To 91
    Dim As UByte Ptr p
    Dim As Integer f2
    Print #2, "unsigned char screeninfo" + Str(f) + "[] = {"
    p = Peek(UShort, file - &h100 + &h786c + f*2) + file - &h100
    Print #2, !"\t " + Str(*p) + ", " + Str(*(p+1)) + ", " + Str(*(p+2)) + ", " + Str(*(p+3)) + ", "
    Print #2, !"\t " + Str(*(p+4)) + ", "
    
    f2 = *(p+4)
    p += 5
	
	'if *p <> 128 andalso f2 > 0 then
    
    While f2 > 0
        dim as integer temp_sprite_number = *(p+1) ' number of sprites to make
        
        buffer = !"\t "
		if *p = 64 then buffer += "0" else buffer += Str(*(p+0))
		buffer += _
                               ", " + Str(*(p+1)) + ", " + _
                 Str(*(p+3)) + ", " + Str(*(p+4)) + ",             "
        Scope 
            Dim As UByte Ptr p2
            Dim As UByte temp
			' ptr to animation info
            p2 = file - &h100 + Peek(UShort, p + 5)
            buffer += Str(*p2) + ", " + Str(*(p2+1)) + ", " + Str(*(p2+2)) + ", "


            temp = lookup_num2(Peek(UShort, p2 + 5))
			' hack to differentiate horizontal and vertical sparkles
            If temp = 3 Then temp = IIf(Peek(UByte, p2 + 8) <> 0, 7, 3) 
			' hack for bridge
			if *p = 64 then temp = 9
            buffer += Str(temp) + ","'+ "   ## " + Hex(Peek(UShort, p2 + 5)) 
        End Scope 
		
        Print #2, buffer
        p += 7
        f2 -= 1
    Wend   
	'else
	'	p += 7
	'end if
	
    If *(p) = 0 Then buffer = !"\t 0 //no screen procedure"
    If *(p) = 1 Then
        If Peek(UShort, p + 1) = &h2016 Then buffer = !"\t 1 // right elevator"
        If Peek(UShort, p + 1) = &h1ff8 Then buffer = !"\t 2 // left elevator"
        If Peek(UShort, p + 1) = &h147a Then buffer = !"\t 3 // final screen"
    End If  
    Print #2, buffer
	Print #2, !"};"
Next 

' screeninfos array
Print #2, !"unsigned char *SCREENINFOS[92] = {"
For y As Integer = 0 To 18
    buffer = !"\t "
    For x As Integer = 0 To 4
        buffer += "screeninfo" + Str(y*5+x)
        If (y * 5)+ x = 91 Then Exit For 
        If x = 4 andalso y = 18 Then exit for
		buffer += ", "
    Next
    Print #2, buffer
Next 
Print #2, !"};"

Close #2
